<template>
  <div class="activeDetail">
    <div class="activeDetail-main" v-if="powers.some((i) => i == '007')">
      <el-tabs v-model="activeTabs">
        <el-tab-pane label="新建活动" name="0" v-if="queryType === 'add'">
          <base-form
            v-if="newTime !== ''"
            :type="queryType"
            :id="queryId"
            :newTime="newTime"
            :sitem="sitem"
            @refresh="refresh"
          />
        </el-tab-pane>
        <el-tab-pane label="活动详情" name="1" v-if="queryType !== 'add'">
          <el-collapse v-model="activeNames" style="margin: -18px 0 0 0">
            <el-collapse-item title="活动详情" name="0">
              <base-form
                v-if="newTime !== ''"
                :type="queryType"
                :id="queryId"
                :newTime="newTime"
                :sitem="sitem"
                @refresh="refresh"
              />
            </el-collapse-item>
            <el-collapse-item
              title="产品部门审批"
              name="1"
              v-if="status === '0' && ppowers.some((i) => i == '0')"
            >
              <exam-form
                :statusList="statusList"
                :newTime="newTime"
                :disabled="false"
                :isMust="false"
                @searchChange="examForm"
              />
            </el-collapse-item>
            <el-collapse-item
              title="采购部定价"
              name="2"
              v-if="status === '1' && ppowers.some((i) => i == '1')"
            >
              <finance-exam-one-form
                v-if="newTime !== ''"
                :type="queryType"
                :id="queryId"
                :newTime="newTime"
                :sitem="sitem"
                @refresh="initData()"
              />
            </el-collapse-item>

            <el-collapse-item
              title="财务定价"
              name="3"
              v-if="status === '2' && ppowers.some((i) => i == '2')"
            >
              <finance-exam-two-form
                v-if="newTime !== ''"
                :type="queryType"
                :id="queryId"
                :newTime="newTime"
                :sitem="sitem"
                @refresh="initData()"
              />
            </el-collapse-item>

            <el-collapse-item
              title="财务审核定价"
              name="4"
              v-if="status === '3' && ppowers.some((i) => i == '3')"
            >
              <finance-exam-three-form
                v-if="newTime !== ''"
                :type="queryType"
                :id="queryId"
                :newTime="newTime"
                :sitem="sitem"
                @refresh="initData()"
              />
            </el-collapse-item>
          </el-collapse>
        </el-tab-pane>
        <el-tab-pane label="审批记录" name="2" v-if="queryType !== 'add'">
          <process-time-line
            v-if="newTime !== ''"
            :newTime="newTime"
            :type="'HD'"
            :orderCode="queryId"
          />
        </el-tab-pane>

        <el-tab-pane label="流程图" name="3"  v-if="queryType !== 'add'">
          <flow-chart process_id="17" type="HD" :orderCode="queryId" />
       </el-tab-pane>
      </el-tabs>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import asyncRequest from "@/apis/service/goodStore/active";
import resToken from "@/mixins/resToken";
import { mapGetters } from "vuex";
import baseForm from "./components/baseForm";
import financeExamOneForm from "./components/finance-exam-one-form";
import financeExamTwoForm from "./components/finance-exam-two-form";
import financeExamThreeForm from "./components/finance-exam-three-form";
export default {
  name: "activeDetail",
  mixins: [resToken],
  components: {
    baseForm,
    financeExamOneForm,
    financeExamTwoForm,
    financeExamThreeForm,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),

    powers() {
      const tran =
        this.$store.getters.btnList.find((i) => i.menu_route == "activeDetail") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
    ppowers() {
      const tran =
        this.$store.getters.roleProcess.find((i) => i.process_type === "HD") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },

  data() {
    return {
      statusList: [],
      size: "small",
      activeTabs: "1",
      activeNames: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
      newTime: "",
      loading: false,
      queryType: "",
      queryId: "",
      status: "",
      sitem: null,
    };
  },
  mounted() {
    this.initForm();
  },
  methods: {
    async initForm() {
      const { id, type } = this.$route.query;
      this.queryId = id;
      this.queryType = type;
      this.activeTabs = type === "add" ? "0" : "1";
      this.loading = true;
      if (this.queryType === "add") {
        this.sitem = {};
        this.getNewTime();
      } else {
        await this.initData();
      }

      this.loading = false;
    },
    // 点击业务审核的保存按钮

    async examForm(e) {
      console.log(e);
      if (!this.loading) {
        let model = {
          activity_code: this.queryId,
          status: e.state === "1" ? "1" : "8",
          remark: e.remark,
        };
        await this.setstatus("提交产品部门审核", model);
      }
    },
    async setstatus(detail, model) {
      await this.$confirm(`确定要${detail}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          let res = await asyncRequest.actstatus(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "提交成功！",
              message: "",
            });
            await this.initForm();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    handleClick(row) {
      console.log(row);
    },
    refresh(e) {
      this.routeReGoto("active", {});
    },
    async initData() {
      this.loading = true;
      const { code, message, data } = await asyncRequest.detail({
        activity_code: this.queryId,
      });
      this.loading = false;
      if (code === 0) {
        this.sitem = JSON.parse(JSON.stringify(data));
        const { status } = this.sitem;
        this.status = status;
        this.getNewTime();
      } else if (code >= 100 && code <= 104) {
        await this.logout();
      } else {
        this.$message.warning(message);
      }
    },
    getNewTime() {
      this.newTime = new Date().valueOf();
    },
  },
};
</script>
<style lang="scss" scoped>
.activeDetail {
  // position: relative;
  // height: 100%;
  // width: 100%;
  box-sizing: border-box;
  .activeDetail-main {
    // overflow-y: scroll;
    // position: relative;
    padding: 10px;
    // height: 100%;
    width: 100%;
  }
  .activeDetail-title {
    border-top: 1px solid #ebeef5;
    span {
      height: 50px;
      line-height: 50px;
      font-family: "微软雅黑", sans-serif;
      font-weight: 400;
      font-style: normal;
      font-size: 16fpx;
      text-align: left;
    }
  }
  /deep/ .ddiv {
    border-top: 1px solid #dcdfe6;
  }
  /deep/ .dtitle {
    width: 40px;
    text-align: center;
    height: 100%;
    min-height: 100%;
    ul {
      padding: 12px 0 0 0;
    }
  }
  /deep/ .dmain {
    padding: 20px 0 0 0;
    width: calc(100% - 40px);
    border-left: 1px solid #dcdfe6;
  }
}
</style>
